//---------------------------------------------------------------------------

#ifndef Krizovatka_Unit1H
#define Krizovatka_Unit1H
//---------------------------------------------------------------------------

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Graphics.hpp>
#include <Mask.hpp>
#include <Dialogs.hpp>



//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TLabel *Label1;
        TLabel *Label2;
        TComboBox *ComboBox1;
        TComboBox *ComboBox2;
        TMainMenu *MainMenu1;
        TMenuItem *Krizovatka1;
        TMenuItem *Nova1;
        TMenuItem *N1;
        TMenuItem *Koniec1;
        TMenuItem *Info1;
        TMenuItem *Oprograme1;
        TButton *Pouzi_0;
        TStringGrid *Iv_grid;
        TStringGrid *StringGrid1;
        TStatusBar *StatusBar1;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TImage *Image1;
        TImageList *ImageList1;
        TImage *Image2;
        TImage *Image3;
        TLabel *Label6;
        TTabSheet *TabSheet4;
        TLabel *Label7;
        TLabel *Label8;
        TLabel *L1_label;
        TMaskEdit *L1_edit;
        TLabel *L2_label;
        TMaskEdit *L2_edit;
        TMaskEdit *L3_edit;
        TLabel *L3_label;
        TLabel *v1_label;
        TMaskEdit *v1_edit;
        TLabel *v2_label;
        TMaskEdit *v2_edit;
        TButton *Pouzi_1;
        TSaveDialog *SaveDialog1;
        TMenuItem *Uloz1;
        TLabel *Label9;
        TLabel *Label10;
        TStringGrid *StringGrid2;
        TLabel *Label11;
        TTabSheet *TabSheet5;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *Label14;
        TStringGrid *StringGrid3;
        TLabel *Label15;
        TLabel *Label16;
        TLabel *Label17;
        TButton *Uloz;
        TImage *plan;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Pouzi_0Click(TObject *Sender);
        void __fastcall StringGrid1SelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall Pouzi_1Click(TObject *Sender);
        void __fastcall Uloz1Click(TObject *Sender);
        void __fastcall StringGrid2SelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall Nova1Click(TObject *Sender);
        void __fastcall Koniec1Click(TObject *Sender);
        void __fastcall Oprograme1Click(TObject *Sender);
        

private:	// User declarations
public:		// User declarations
        __fastcall TForm1(TComponent* Owner);

        int help , help_1;
        int matica[5][5];
        int index_optimalne;
        CESTA hlavna, vedlajsia;
        PRUH pruhy[POC_PRUHOV];
        FAZA faza[POC_FAZ];
        TAB_STRAT_CASY straty[6];
        float tab_medzicas [SKUT_POC_PRUHOV][SKUT_POC_PRUHOV];

        int L1;
        int L2;
        int L3;
        int v1;
        int v2;
        int tb;

        float Y;
        float zlta;
        float L;
        float c0;
        float cn;

        bool nova;
        int cislo_planu;

        int vypis(AnsiString vypis, int typ_vypisu);
        void vypis_status(AnsiString text);
        void vypoc_Ip(void);
        void vytvor_pruhy(void);
        void zapis(FILE *subor);
        void stupen_saturacie(void);
        void priprav_tabulku_2(void);
        void tab_medzicasov(void);
        void vytvor_fazy(void);
        void stratove_casy(void);
        void vykonnost_krizovatky(void);
        void signalny_plan(FILE *subor);

        

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
